import { defineStore } from 'pinia';
import db from './db';
const account_key_name = `IEE_account`;
export const useLogin = defineStore('userInfo', {
	state: () => ({
		/** 用户ID  0 Employee  1 OuterUser  2 Agent */
		UserID: 0,
		/** 用户类型 */
		UserType: 0,
		/** 真实姓名 */
		RealName: '',
		// 登录时获取的Token
		Token: null,
		// 记录退出登录之前的页面路
		preLoginPagePath: db.get('path') || '',
	}),
	actions: {
		/**
		 * @description 退出
		 */
		logOut() {
			// 清楚令牌信息和账户信息
			this.clear();
		},

		/**
		 * 从本地存储中加载令牌
		 */
		loadfromlocalstorage() {
			const user = db.get(account_key_name);
			if (user) {
				this.UserID = user.UserID;
				this.UserType = user.UserType;
				this.Token = user.Token;
				this.RealName = user.RealName;
			}
		},
		/**
		 * 设置登陆后跳转的页面
		 */
		preLoginPageRoute(path) {
			//将路径存入缓存
			db.set('path', path);
			path = db.get('path');
			this.preLoginPagePath = path;
		},

		/**
		 * 初始化用户信息
		 */
		init(user) {
			let UserInfo = {
				UserID: 0,
				UserType: 0,
				Token: '',
			};
			if (!user) {
				user = db.get(account_key_name);
				UserInfo = { ...user };
			}
			if (user) {
				this.UserID = user.UserID;
				this.UserType = user.UserType;
				this.Token = user.Token;
				this.RealName = user.RealName;

				UserInfo.UserID = user.UserID;
				UserInfo.UserType = user.UserType;
				UserInfo.Token = user.Token;
			}
			db.set(account_key_name, user);
		},
		// 获取用户信息
		getUserInfo() {
			const user = db.get(account_key_name);

			let userInfo = {
				/** 用户ID  0 Employee  1 OuterUser  2 Agent */
				UserID: this.UserID,
				/** 用户类型 */
				UserType: this.UserType,
				/** 真实姓名 */
				RealName: this.RealName,
				// 登录时获取的Token
				Token: this.Token,
			};
			if (user) {
				userInfo = user;
				return userInfo;
			}
			return userInfo;
		},

		/**
		 * 清楚用户信息
		 */
		clear() {
			this.UserID = 0;
			this.UserType = 0;
			this.RealName = '';
			this.Token = '';
			db.remove(account_key_name);
		},
	},
});
